namespace TLS.Net.NativeAPI.BIO
{
    public enum BioControlOperation
    {
        BIO_CTRL_RESET = 1,
        BIO_CTRL_EOF = 2,
        BIO_CTRL_INFO = 3,
        BIO_CTRL_SET = 4,
        BIO_CTRL_GET = 5,
        BIO_CTRL_PUSH = 6,
        BIO_CTRL_POP = 7,
        BIO_CTRL_GET_CLOSE = 8,
        BIO_CTRL_SET_CLOSE = 9,
        BIO_CTRL_PENDING = 10,
        BIO_CTRL_FLUSH = 11,
        BIO_CTRL_DUP = 12,
        BIO_CTRL_WPENDING = 13,
        BIO_CTRL_SET_CALLBACK = 14,
        BIO_CTRL_GET_CALLBACK = 15,

        BIO_CTRL_PEEK = 29,
        BIO_CTRL_SET_FILENAME = 30,


        BIO_CTRL_DGRAM_CONNECT = 31,
        BIO_CTRL_DGRAM_SET_CONNECTED = 32,
        BIO_CTRL_DGRAM_SET_RECV_TIMEOUT = 33,
        BIO_CTRL_DGRAM_GET_RECV_TIMEOUT = 34,
        BIO_CTRL_DGRAM_SET_SEND_TIMEOUT = 35,
        BIO_CTRL_DGRAM_GET_SEND_TIMEOUT = 36,

        BIO_CTRL_DGRAM_GET_RECV_TIMER_EXP = 37,
        BIO_CTRL_DGRAM_GET_SEND_TIMER_EXP = 38,


        BIO_CTRL_DGRAM_MTU_DISCOVER = 39,


        BIO_CTRL_DGRAM_QUERY_MTU = 40,
        BIO_CTRL_DGRAM_GET_FALLBACK_MTU = 47,
        BIO_CTRL_DGRAM_GET_MTU = 41,
        BIO_CTRL_DGRAM_SET_MTU = 42,

        BIO_CTRL_DGRAM_MTU_EXCEEDED = 43,

        BIO_CTRL_DGRAM_GET_PEER = 46,
        BIO_CTRL_DGRAM_SET_PEER = 44,

        BIO_CTRL_DGRAM_SET_NEXT_TIMEOUT = 45,
        BIO_CTRL_DGRAM_SET_DONT_FRAG = 48,

        BIO_CTRL_DGRAM_GET_MTU_OVERHEAD = 49,


        BIO_CTRL_DGRAM_SCTP_SET_IN_HANDSHAKE = 50,

        BIO_CTRL_DGRAM_SCTP_ADD_AUTH_KEY = 51,
        BIO_CTRL_DGRAM_SCTP_NEXT_AUTH_KEY = 52,
        BIO_CTRL_DGRAM_SCTP_AUTH_CCS_RCVD = 53,
        BIO_CTRL_DGRAM_SCTP_GET_SNDINFO = 60,
        BIO_CTRL_DGRAM_SCTP_SET_SNDINFO = 61,
        BIO_CTRL_DGRAM_SCTP_GET_RCVINFO = 62,
        BIO_CTRL_DGRAM_SCTP_SET_RCVINFO = 63,
        BIO_CTRL_DGRAM_SCTP_GET_PRINFO = 64,
        BIO_CTRL_DGRAM_SCTP_SET_PRINFO = 65,
        BIO_CTRL_DGRAM_SCTP_SAVE_SHUTDOWN = 70,

        BIO_CTRL_DGRAM_SET_PEEK_MODE = 71,

        BIO_CTRL_GET_KTLS_SEND = 73,
        BIO_CTRL_GET_KTLS_RECV = 76
    }
}